﻿#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=program.ico
#AutoIt3Wrapper_Outfile=AHV.exe
#AutoIt3Wrapper_Res_Description=AHV   AutoIt-Hex-Viewer
#AutoIt3Wrapper_Res_Fileversion=1.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiEdit.au3>
#include <GuiScrollBars.au3>
#include <ScrollBarsConstants.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>

Opt('GUIOnEventMode', 1)
Global Const $CRYPT_STRING_HEXASCIIADDR = 0x0000000B
Global Const $sTitle = 'AHV   AutoIt-Hex-Viewer'
Global Const $sVersion = '1.1.0.0'
Global Const $sDate = '05.09.2015'

Global $sLoadfile
If Not @Compiled Then
	$sLoadfile = FileOpenDialog($sTitle, @DesktopDir & '\', 'All (*.*)', 3)
	If @error Then Exit 0
Else
	If $CmdLine[0] = 0 Then
		$sLoadfile = FileOpenDialog($sTitle, @DesktopDir & '\', 'All (*.*)', 3)
		If @error Then Exit 0
	Else
		If Not FileExists($CmdLine[1]) Then Exit 0
		$sLoadfile = $CmdLine[1]
	EndIf
EndIf
$sLoadfile = FileGetLongName($sLoadfile, 1)
Global $hFile = _WinAPI_CreateFile($sLoadfile, 2, 2)
If $hFile = 0 Then Exit MsgBox(16, $sTitle, 'Fehler! Die Datei konnte nicht geöffnet werden!')
Global $iSize = _WinAPI_GetFileSizeEx($hFile)

Global $hHexGui = GUICreate($sTitle & ': "' & $sLoadfile & '"', 810, 586, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION))
GUISetOnEvent($GUI_EVENT_CLOSE, '_HexGuiClose', $hHexGui)
GUISetIcon(@ScriptDir & '\program.ico', 0, $hHexGui)

Global $idHexView = GUICtrlCreateEdit('', 0, 0, 810, 586, BitOR($ES_READONLY, $ES_MULTILINE))
GUICtrlSetFont(-1, 12, 400, 0, 'Courier New', 5)
GUICtrlSetBkColor(-1, 0xFFFFFF)

Global $aidDummy[6]
For $i = 0 To UBound($aidDummy) - 1
	$aidDummy[$i] = GUICtrlCreateDummy()
	GUICtrlSetOnEvent(-1, '_KeyboardControl')
Next
Global $aAccelKeys[6][2] = [['{UP}', $aidDummy[0]], ['{DOWN}', $aidDummy[1]], ['{HOME}', $aidDummy[2]], ['{END}', $aidDummy[3]], ['{PGUP}', $aidDummy[4]], ['{PGDN}', $aidDummy[5]]]

_GUIScrollBars_Init($hHexGui, -1, Ceiling($iSize / 16) + 2)
GUISetState(@SW_SHOW, $hHexGui)
GUISetAccelerators($aAccelKeys)
GUIRegisterMsg($WM_VSCROLL, 'WM_VSCROLL')

;Register callback
Global Const $MSLLHOOKSTRUCT = $tagPOINT & ';dword mouseData;dword flags;dword time;ulong_ptr dwExtraInfo'
Global $hKey_Proc = DllCallbackRegister('_MouseWheel', 'int', 'int;ptr;ptr')
Global $hM_Module = DllCall('kernel32.dll', 'hwnd', 'GetModuleHandle', 'ptr', 0)
Global $hM_Hook = DllCall('user32.dll', 'hwnd', 'SetWindowsHookEx', 'int', $WH_MOUSE_LL, 'ptr', DllCallbackGetPtr($hKey_Proc), 'hwnd', $hM_Module[0], 'dword', 0)
OnAutoItExitRegister('OnAutoItExit')

_HexViewerSetData($idHexView, 0)

WinWaitClose($hHexGui)
Exit

Func OnAutoItExit()
	DllCall('user32.dll', 'int', 'UnhookWindowsHookEx', 'hwnd', $hM_Hook[0])
	$hM_Hook[0] = 0
	DllCallbackFree($hKey_Proc)
	$hKey_Proc = 0
EndFunc   ;==>OnAutoItExit

Func _HexGuiClose()
	_WinAPI_CloseHandle($hFile)
	GUIDelete($hHexGui)
EndFunc   ;==>_HexGuiClose

Func _HexViewerSetData($CtrlId, $iFilePointer)
	Local $tBuffer, $nBytes, $sText, $sHEXASCIIADDR
	$tBuffer = DllStructCreate('byte[512]')
	$iFilePointer = _WinAPI_SetFilePointer($hFile, $iFilePointer)
	If $iFilePointer <> -1 Then
		_WinAPI_ReadFile($hFile, $tBuffer, DllStructGetSize($tBuffer), $nBytes)
		$sText = BinaryToString(DllStructGetData($tBuffer, 1))
		$tBuffer = 0
		$sHEXASCIIADDR = _WinAPI_CryptBinaryToString($sText, $CRYPT_STRING_HEXASCIIADDR)
		$sHEXASCIIADDR = _ConvertHexAddr($sHEXASCIIADDR, $iFilePointer, $nBytes)
		GUICtrlSetData($CtrlId, $sHEXASCIIADDR)
	EndIf
EndFunc   ;==>_HexViewerSetData

Func _ConvertHexAddr($sText, $iStart, $nBytes)
	Local $sOut = '', $iAddr
	Local $aText = StringSplit($sText, @CRLF, 3)
	If @error Then Return $sText
	For $i = 0 To UBound($aText) - 2
		$iAddr = Dec(StringLeft($aText[$i], 4)) + $iStart
		$sOut &= Hex($iAddr, 8) & '   ' & StringMid($aText[$i], 6) & @CRLF
	Next
	Return $sOut
EndFunc   ;==>_ConvertHexAddr

Func _KeyboardControl()
	Local $tSCROLLINFO = _GUIScrollBars_GetScrollInfoEx($hHexGui, $SB_VERT)
	Local $iPos = DllStructGetData($tSCROLLINFO, 'nPos')
	Switch @GUI_CtrlId
		Case $aidDummy[0] ; Line up
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos - 1)
		Case $aidDummy[1] ; Line down
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos + 1)
		Case $aidDummy[2] ; Home
			DllStructSetData($tSCROLLINFO, 'nPos', 0)
		Case $aidDummy[3] ; End
			DllStructSetData($tSCROLLINFO, 'nPos', Ceiling($iSize / 16) + 2)
		Case $aidDummy[4] ; Page up
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos - 32)
		Case $aidDummy[5] ; Page down
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos + 32)
	EndSwitch
	_GUIScrollBars_SetScrollInfo($hHexGui, $SB_VERT, $tSCROLLINFO)
	_GUIScrollBars_GetScrollInfo($hHexGui, $SB_VERT, $tSCROLLINFO)
	$iPos = DllStructGetData($tSCROLLINFO, 'nPos')
	_HexViewerSetData($idHexView, $iPos * 16)
	$tSCROLLINFO = 0
EndFunc   ;==>_KeyboardControl

Func _MouseWheel($nCode, $wParam, $lParam)
	Local $info, $mouseData, $ret
	If $nCode < 0 Or Not WinActive($hHexGui) Then
		$ret = DllCall('user32.dll', 'long', 'CallNextHookEx', 'hwnd', $hM_Hook[0], _
				'int', $nCode, 'ptr', $wParam, 'ptr', $lParam)
		Return $ret[0]
	EndIf
	$info = DllStructCreate($MSLLHOOKSTRUCT, $lParam)
	$mouseData = DllStructGetData($info, 3)
	Switch $wParam
		Case $WM_MOUSEWHEEL
			Local $tSCROLLINFO = _GUIScrollBars_GetScrollInfoEx($hHexGui, $SB_VERT)
			Local $iPos = DllStructGetData($tSCROLLINFO, 'nPos')
			If _WinAPI_HiWord($mouseData) > 0 Then ; Wheel Up
				DllStructSetData($tSCROLLINFO, 'nPos', $iPos - 1)
			Else ; Wheel Down
				DllStructSetData($tSCROLLINFO, 'nPos', $iPos + 1)
			EndIf
			_GUIScrollBars_SetScrollInfo($hHexGui, $SB_VERT, $tSCROLLINFO)
			_GUIScrollBars_GetScrollInfo($hHexGui, $SB_VERT, $tSCROLLINFO)
			$iPos = DllStructGetData($tSCROLLINFO, 'nPos')
			_HexViewerSetData($idHexView, $iPos * 16)
			$tSCROLLINFO = 0
	EndSwitch
	$ret = DllCall('user32.dll', 'long', 'CallNextHookEx', 'hwnd', $hM_Hook[0], _
			'int', $nCode, 'ptr', $wParam, 'ptr', $lParam)
	Return $ret[0]
EndFunc   ;==>_MouseWheel

Func WM_VSCROLL($hWnd, $iMsg, $wParam, $lParam)
	#forceref $iMsg, $lParam
	Local $iScrollCode = BitAND($wParam, 0x0000FFFF)
	Local $iIndex = -1, $iCharY, $iPosY
	Local $iMin, $iMax, $iPage, $iPos, $iTrackPos
	For $x = 0 To UBound($__g_aSB_WindowInfo) - 1
		If $__g_aSB_WindowInfo[$x][0] = $hWnd Then
			$iIndex = $x
			$iCharY = $__g_aSB_WindowInfo[$iIndex][3]
			ExitLoop
		EndIf
	Next
	If $iIndex = -1 Then Return 0
	Local $tSCROLLINFO = _GUIScrollBars_GetScrollInfoEx($hWnd, $SB_VERT)
	$iMin = DllStructGetData($tSCROLLINFO, 'nMin')
	$iMax = DllStructGetData($tSCROLLINFO, 'nMax')
	$iPage = 32
	$iPosY = DllStructGetData($tSCROLLINFO, 'nPos')
	$iPos = $iPosY
	$iTrackPos = DllStructGetData($tSCROLLINFO, 'nTrackPos')
	Switch $iScrollCode
		Case $SB_LINEUP ; user clicked the top arrow
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos - 1)
		Case $SB_LINEDOWN ; user clicked the bottom arrow
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos + 1)
		Case $SB_PAGEUP ; user clicked the scroll bar shaft above the scroll box
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos - $iPage)
		Case $SB_PAGEDOWN ; user clicked the scroll bar shaft below the scroll box
			DllStructSetData($tSCROLLINFO, 'nPos', $iPos + $iPage)
		Case $SB_THUMBTRACK ; user dragged the scroll box
			DllStructSetData($tSCROLLINFO, 'nPos', $iTrackPos)
	EndSwitch
	DllStructSetData($tSCROLLINFO, 'fMask', $SIF_POS)
	_GUIScrollBars_SetScrollInfo($hWnd, $SB_VERT, $tSCROLLINFO)
	_GUIScrollBars_GetScrollInfo($hWnd, $SB_VERT, $tSCROLLINFO)
	$iPos = DllStructGetData($tSCROLLINFO, 'nPos')
	If $iPos <> $iPosY Then
		_HexViewerSetData($idHexView, $iPos * 16)
		$iPosY = $iPos
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_VSCROLL

; Author: Kleiner (www.autoit.de)
Func _WinAPI_CryptBinaryToString($vString, $Flag)
	Local $Struc = DllStructCreate('byte[' & BinaryLen($vString) & ']')
	DllStructSetData($Struc, 1, $vString)
	Local $Call = DllCall('crypt32.dll', 'int', 'CryptBinaryToString', _
			'ptr', DllStructGetPtr($Struc), _
			'dword', DllStructGetSize($Struc), _
			'dword', $Flag, _
			'ptr', 0, _
			'dword*', 0)
	If @error Or Not $Call[0] Then Return SetError(1, 0, '')
	Local $iSize = $Call[5]
	Local $Struc_1 = DllStructCreate('char[' & $iSize & ']')
	$Call = DllCall('crypt32.dll', 'int', 'CryptBinaryToString', _
			'ptr', DllStructGetPtr($Struc), _
			'dword', DllStructGetSize($Struc), _
			'dword', $Flag, _
			'ptr', DllStructGetPtr($Struc_1), _
			'dword*', $iSize)
	If @error Or Not $Call[0] Then Return SetError(2, 0, '')
	Return SetError(0, 0, DllStructGetData($Struc_1, 1))
EndFunc   ;==>_WinAPI_CryptBinaryToString
